unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DB, DBTables, StdCtrls, FileCtrl, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Source: TTable;
    Panel1: TPanel;
    bGenrate: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    tg: TMemo;
    sfName: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    TabSheet3: TTabSheet;
    tc: TMemo;
    Panel2: TPanel;
    FilterComboBox1: TFilterComboBox;
    DriveComboBox1: TDriveComboBox;
    TabSheet4: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    About: TMemo;
    cbIPB: TCheckBox;
    procedure bGenrateClick(Sender: TObject);
    procedure sfNameChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.bGenrateClick(Sender: TObject);
var
 i: LongInt;
 Ast, Required, op, dt: String;
begin
  Source.Close;
  Source.Databasename := '';
  Source.TableName := sfName.FileName;
  Source.Open;
  tg.Lines.Clear;
  tg.Lines.Add('{ ************************** '+ExtractFileName(Source.TableName)+ ' ************************** }');
  Source.FieldDefs.Update;
  tg.Lines.Add('with TTable.Create(Application) do begin');
  tg.Lines.Add('');
  tg.Lines.Add('  Active := False;');
  tg.Lines.Add('  DatabaseName := ''C:\TEMP'';          { * Change the DatabaseName * }');
  tg.Lines.Add('  TableName := '''+ExtractFileName(Source.TableName)+''';');
  if Source.TableType = ttParadox then tg.Lines.Add('  TableType := ttParadox;');
  if Source.TableType = ttDBase then tg.Lines.Add('  TableType := ttDBase;');
  if Source.TableType = ttDefault then tg.Lines.Add('  TableType := ttDefault;');
  if Source.TableType = ttASCII then tg.Lines.Add('  TableType := ttASCII;');

  tg.Lines.Add('');
  tg.Lines.Add('  { *************** Fields of Table "'+ExtractFileName(Source.TableName)+'" **************** }');

  if Source.FieldDefs.Count > 0 then
  begin
    for I := 0 to Source.FieldDefs.Count-1 do with Source.FieldDefs do
    begin
      dt := '';
      if Items[i].DataType = ftUnknown then dt := 'ftUnknown';
      if Items[i].DataType = ftTypedBinary then dt := 'ftTypedBinary';
      if Items[i].DataType = ftDBaseOle then dt := 'ftDBaseOle';
      if Items[i].DataType = ftParadoxOle then dt := 'ftParadoxOle';
      if Items[i].DataType = ftBlob then dt := 'ftBlob';
      if Items[i].DataType = ftFmtMemo then dt := 'ftFmtMemo';
      if Items[i].DataType = ftGraphic then dt := 'ftGraphic';
      if Items[i].DataType = ftMemo then dt := 'ftMemo';
      if Items[i].DataType = ftBlob then dt := 'ftBlob';
      if Items[i].DataType = ftAutoInc then dt := 'ftAutoInc';
      if Items[i].DataType = ftVarBytes then dt := 'ftVarBytes';
      if Items[i].DataType = ftBytes then dt := 'ftBytes';
      if Items[i].DataType = ftDateTime then dt := 'ftDateTime';
      if Items[i].DataType = ftTime then dt := 'ftTime';
      if Items[i].DataType = ftDate then dt := 'ftDate';
      if Items[i].DataType = ftBCD then dt := 'ftBCD';
      if Items[i].DataType = ftFloat then dt := 'ftFloat';
      if Items[i].DataType = ftCurrency then dt := 'ftCurrency';
      if Items[i].DataType = ftBoolean then dt := 'ftBoolean';
      if Items[i].DataType = ftString then dt := 'ftString';
      if Items[i].DataType = ftInteger then dt := 'ftInteger';
      if Items[i].DataType = ftSmallInt then dt := 'ftSmallInt';
      if Items[i].DataType = ftWord then dt := 'ftWord';

      if Items[i].Required then
        Required := 'True'
      else
        Required := 'False';

      tg.Lines.Add('  FieldDefs.Add('''+Items[i].Name+''', '+dt+', '+ IntToStr(Items[i].Size)+', '+Required+');');
    end;
  end;
  Source.IndexDefs.Update;
  if Source.IndexDefs.Count > 0 then
  begin
    tg.Lines.Add('');
    tg.Lines.Add('  { *************** Indexes of Table "'+ExtractFileName(Source.TableName)+'" ****************  }');
    for I := 0 to Source.IndexDefs.Count-1 do with Source.IndexDefs do
    begin
      Op := '';
      if ixPrimary in Items[i].Options  then op := 'ixPrimary';
      if ixUnique in Items[i].Options then
        if Op = '' then op := 'ixUnique' else op := Op + ', ixUnique';
      if ixDescending in Items[i].Options then
        if Op = '' then op := 'ixDescending' else op := Op + ', ixDescending';
      if ixExpression in Items[i].Options then
        if Op = '' then op := 'ixExpression' else op := Op + ', ixExpression';
      if ixCaseInsensitive in Items[i].Options then
        if Op = '' then op := 'ixCaseInsensitive' else op := Op + ', ixCaseInsensitive';

      tg.Lines.Add('  IndexDefs.Add('''+Items[i].Name+''', '''+ Items[i].Fields+''', ['+op+']);');

    end;
  end;

  tg.Lines.Add('  CreateTable;');
  tg.Lines.Add('  Free;');
  tg.Lines.Add('');
  tg.Lines.Add('end;');
  { ************************************************************************** }
  tc.Lines.Clear;
  tc.Lines.Add('Source.Close;');
  tc.Lines.Add('Dest.Close;');
  tc.Lines.Add('Source.TableName := '''+Source.TableName+''';');
  tc.Lines.Add('Dest.DataBaseName := '''+'C:\TEMP'+''';');
  tc.Lines.Add('Dest.TableName := '''+ExtractFileName(Source.TableName)+''';');
  tc.Lines.Add('Source.Open;');
  tc.Lines.Add('Dest.Open;');
  if cbIPB.Checked then
  begin
    tc.Lines.Add('ProgressBar1.Min := 1;');
    tc.Lines.Add('ProgressBar1.Max := Source.RecordCount;');
    tc.Lines.Add('ProgressBar1.Position := 1;');
  end;

  tc.Lines.Add('While not Source.Eof do');
  tc.Lines.Add('begin');
  tc.Lines.Add('  Dest.Append;');

  for I := 0 to Source.FieldDefs.Count-1 do with Source.FieldDefs do
  begin

    dt := '.AsVariant';
    if Items[i].DataType = ftUnknown then dt := '';
    if Items[i].DataType = ftAutoInc then dt := '.';
    if Items[i].DataType = ftDateTime then dt := '.AsDateTime';
    if Items[i].DataType = ftTime then dt := '.AsDateTime';
    if Items[i].DataType = ftDate then dt := '.AsDateTime';
    if Items[i].DataType = ftBCD then dt := '.AsVariant';
    if Items[i].DataType = ftFloat then dt := '.AsFloat';
    if Items[i].DataType = ftCurrency then dt := '.AsCurrency';
    if Items[i].DataType = ftBoolean then dt := '.AsBoolean';
    if Items[i].DataType = ftString then dt := '.AsString';
    if Items[i].DataType = ftInteger then dt := '.AsInteger';
    if Items[i].DataType = ftSmallInt then dt := '.AsInteger';
    if Items[i].DataType = ftWord then dt := '.AsInteger';

    if dt <> '.' then
      tc.Lines.Add('  Dest.FieldByName('''+Items[i].Name+''')'+dt+' := Source.FieldByName('''+Items[i].Name+''')'+dt+' ;');

  end;
  if cbIPB.Checked then
  begin
    tc.Lines.Add('  ProgressBar1.Position := Source.RecNo;');
    tc.Lines.Add('  Application.ProcessMessages;');
  end;
  tc.Lines.Add('  Dest.Post;');
  tc.Lines.Add('  Source.Next;');
  tc.Lines.Add('end;');

end;

procedure TForm1.sfNameChange(Sender: TObject);
begin
  if sfName.FileName <> '' then
    bGenrate.Enabled := True
  else
    bGenrate.Enabled := False;
end;

end.
